package com.madeu.controller.mobile.mobiledevice;

import com.madeu.constants.Constants;
import com.madeu.init.ManagerDraftAction;
import com.madeu.service.mobile.mobiledevice.MobileDeviceService;
import com.madeu.util.HttpUtil;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.servlet.http.HttpServletResponse;
import jakarta.servlet.http.HttpSession;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.multipart.MultipartHttpServletRequest;
import org.springframework.web.servlet.ModelAndView;

import java.util.HashMap;
import com.madeu.common.service.LogHistoryService;

@Slf4j
@Controller
public class MobileDeviceController extends ManagerDraftAction {
    @Autowired
    private MobileDeviceService mobileDeviceService;

    @Autowired
    private LogHistoryService logHistoryService;

    /**
     * 디바이스 푸시 알림 여부 조회
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value = "/mobiledevice/selectDevicePushYn.do")
    public ModelAndView selectDevicePushYn(HttpSession session, HttpServletRequest request,
            HttpServletResponse response) {
        log.debug("MobileDeviceController selectDevicePushYn START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        try {
            if (!mobileCheckLogin(session)) {
                return null;
            } else {
                paramMap.put("muUserId", String.valueOf(session.getAttribute("loginUserId")));
                paramMap.put("deviceUuid", String.valueOf(session.getAttribute("mobileDeviceUuid")));
                map = mobileDeviceService.selectDevicePushYn(paramMap);
            }
        } catch (Exception e) {
            e.printStackTrace();
            return null;
        } finally {
            if (Constants.OK == map.get("msgCode")) {

            } else {
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if (null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc", "정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }
        }
        log.debug("MobileDeviceController selectDevicePushYn END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }

    /**
     * 디바이스 푸시 알림 여부 수정
     *
     * @param request
     * @param response
     * @return
     */
    @RequestMapping(value = "/mobiledevice/updateDevicePushYn.do")
    public ModelAndView updateDevicePushYn(HttpSession session, HttpServletRequest request,
            HttpServletResponse response, MultipartHttpServletRequest file) {
        log.debug("MobileDeviceController updateDevicePushYn START");

        HashMap<String, Object> paramMap = HttpUtil.getParameterMap(request);
        HashMap<String, Object> map = new HashMap<String, Object>();

        StringBuffer errorMsg = new StringBuffer();

        try {
            if (!mobileCheckLogin(session)) {
                return null;
            } else {
                paramMap.put("membershipAccount", String.valueOf(session.getAttribute("mobileLoginId")));
                paramMap.put("muUserId", String.valueOf(session.getAttribute("loginUserId")));
                paramMap.put("regId", String.valueOf(session.getAttribute("loginUserId")));
                paramMap.put("modId", String.valueOf(session.getAttribute("loginUserId")));
                paramMap.put("deviceUuid", String.valueOf(session.getAttribute("mobileDeviceUuid")));
                map = mobileDeviceService.updateDevicePushYn(paramMap);
            }
        } catch (Exception e) {
            e.printStackTrace();
            errorMsg.append(e);
        } finally {
            if (Constants.OK == map.get("msgCode")) {

            } else {
                map.put("msgCode", Constants.FAIL);
                map.put("success", false);
                if (null == map.get("msgDesc") || ("").equals(map.get("msgDesc"))) {
                    map.put("msgDesc", "정상적으로 수행되지 않았습니다. 관리자에게 문의하시기 바랍니다.");
                }
            }

            logHistoryService.save("디바이스 푸시 알림 여부 수정", "디바이스", paramMap, map, String.valueOf(errorMsg));
        }
        log.debug("MobileDeviceController updateDevicePushYn END");
        return HttpUtil.makeHashToJsonModelAndView(map);
    }
}
